package com.inca.npbusi.saset.inorder;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.CommandBase;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.inf.hov.Zx_su_price_type_hov;
import com.inca.npbusi.saset.inorder.hov.Husemv_order_dtl_hov;
import com.inca.npx.ste.CSteModelAp;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.hov.bms_sa_goods_price_hov.Bms_sa_goods_price_hov;
import java.awt.Frame;
import java.awt.HeadlessException;
import javax.swing.JCheckBox;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

public class Husemv_order_dtl_ste extends CSteModelAp {
  JCheckBox a;
  
  JCheckBox b;
  
  public Husemv_order_dtl_ste(CFrame frame) throws HeadlessException {
    super(frame, "医院使用单对码");
    this.a = null;
    this.b = null;
  }
  
  public String getTablename() {
    return "HUSEMV_ORDER_DTL_V";
  }
  
  public String getSaveCommandString() {
    return "com.inca.npbusi.saset.inorder.Husemv_order_dtl_ste.保存医院使用单对码";
  }
  
  protected void on_itemvaluechange(int row, String colname, String value) {
    if (colname.equals("goodsname")) {
      setItemValue(row, "operatingid", ClientUserManager.getCurrentUser()
          .getUserid());
      setItemValue(row, "operatingperson", 
          ClientUserManager.getCurrentUser().getUsername());
      setItemValue(row, "operatingmac", 
          ClientUserManager.getCurrentUser().getMac());
      setItemValue(row, "operdate", NpbusiDBHelper.getSysdate());
      setItemValue(row, "baseratio", "1");
      setItemValue(row, "priceid", "");
      String goodsid = getItemValue(row, "goodsid");
      String yljgbm = getItemValue(row, "yljgbm");
      Bms_sa_goods_price_hov hov = new Bms_sa_goods_price_hov();
      hov.setOtherwheres(" ((customid is null or customid = " + 
          getItemValue(row, "yljgbm") + ") and goodsid = " + 
          getItemValue(row, "goodsid") + " and entryid=1)");
      DBTableModel model = hov.showDialog(null, "选择货品价格");
      setItemValue(row, "priceid", model.getItemValue(0, "priceid"));
      Zx_su_price_type_hov suhov = new Zx_su_price_type_hov();
      suhov.setOtherwheres("workflag =6 and goodsid=" + 
          getItemValue(row, "goodsid") + " and entryid=" + 
          ClientUserManager.getCurrentUser().getEntryid());
      DBTableModel sumodel = suhov.showDialog(null, "选择货品采购价格");
      setItemValue(row, "supriceid", sumodel.getItemValue(0, "priceid"));
      doSave();
    } 
    super.on_itemvaluechange(row, colname, value);
  }
  
  public String getHovOtherWheres(int row, String colname) {
    if (colname.equals("goodsid"))
      return "goodsid not in(select  nvl(goodsid,0) goodsid from hrp_goods where yljgbm=" + 
        getItemValue(row, "yljgbm") + " )"; 
    if (colname.equals("priceid")) {
      if (getItemValue(row, "goodsid").equals("")) {
        warnMessage("提示", "货品未选择，请先对照货品！！");
        return "1>2";
      } 
      return " ((customid is null or customid = " + 
        getItemValue(row, "yljgbm") + ") and goodsid = " + 
        getItemValue(row, "goodsid") + " and entryid=1)";
    } 
    if (colname.equals("supriceid")) {
      if (getItemValue(row, "goodsid").equals("")) {
        warnMessage("提示", "货品未选择，请先对照货品！！");
        return "1>2";
      } 
      return "( workflag =6 and goodsid=" + getItemValue(row, "goodsid") + 
        " and entryid=" + 
        ClientUserManager.getCurrentUser().getEntryid() + ")";
    } 
    if (colname.equals("PRICEID")) {
      if (getItemValue(row, "goodsid").equals("")) {
        warnMessage("提示", "货品未选择，请先对照货品！！");
        return "1>2";
      } 
      String customid = getItemValue(row, "HID");
      String goodsid = getItemValue(row, "goodsid");
      String entryid = ClientUserManager.getCurrentUser().getEntryid();
      return String.format("(customid is null or customid =%s) and goodsid=%s and entryid=%s", new Object[] { isNullRe_one(customid), isNullRe_one(goodsid), isNullRe_one(entryid) });
    } 
    return super.getHovOtherWheres(row, colname);
  }
  
  private String isNullRe_one(String exec_text) {
    String return_value = "-1";
    if (exec_text != null && !exec_text.trim().isEmpty())
      return_value = exec_text; 
    return return_value;
  }
  
  protected String getOtherWheres() {
    String entryid = ClientUserManager.getCurrentUser().getEntryid();
    return " entryid=" + entryid;
  }
  
  protected int on_actionPerformed(String command) {
    if (command.equals("库存数据匹配")) {
      String goodsid = getItemValue(getRow(), "goodsid");
      if (goodsid != null && !"".equals(goodsid)) {
        infoMessage("提示", "医院使用单已对码！");
        return -1;
      } 
      chooseStockOrder();
      return 0;
    } 
    return super.on_actionPerformed(command);
  }
  
  private void chooseStockOrder() {
    String hmoveid = getItemValue(getRow(), "HMOVEID");
    String moveId = getItemValue(getRow(), "MOVEID");
    String storageid = getItemValue(getRow(), "storageid");
    String HLOTNO = getItemValue(getRow(), "HLOTNO");
    String hgoodsqty = getItemValue(getRow(), "HGOODSQTY");
    String hid = getItemValue(getRow(), "HID");
    if (hmoveid != null && !"".equals(hmoveid)) {
      infoMessage("提示", "医院已有移库单ID，不允许数据匹配！");
      return;
    } 
    if (moveId != null && !"".equals(moveId)) {
      infoMessage("提示", "已有移库单ID，不允许数据匹配！");
      return;
    } 
    Husemv_order_dtl_hov husemv_order_dtl_hov = new Husemv_order_dtl_hov();
    husemv_order_dtl_hov.setOtherwheres(" STORAGEID=" + storageid + " and LOTNO= '" + HLOTNO + "' and availableqty_truereal >0  ");
    DBTableModel showDialog = husemv_order_dtl_hov.showDialog((Frame)this.frame, "选择库存生成数据");
    if (showDialog == null)
      return; 
    CTable table;
    int[] selectedRows = (table = husemv_order_dtl_hov.getTable()).getSelectedRows();
    DBTableModel dbTableModel = (DBTableModel)table.getModel();
    if (selectedRows.length <= 0)
      return; 
    String goodsid = dbTableModel.getItemValue(selectedRows[0], "GOODSID");
    setItemValue(getRow(), "GOODSID", goodsid);
    setItemValue(getRow(), "GOODSNAME", dbTableModel.getItemValue(selectedRows[0], "GOODSNAME"));
    setItemValue(getRow(), "GOODSTYPE", dbTableModel.getItemValue(selectedRows[0], "GOODSTYPE"));
    String erpgoodsqty = dbTableModel.getItemValue(selectedRows[0], "GOODSQTY");
    String goodsqty = dbTableModel.getItemValue(selectedRows[0], "GOODSQTY");
    int comparaDecimal = DecimalHelper.comparaDecimal(hgoodsqty, goodsqty);
    if (comparaDecimal == -1)
      goodsqty = hgoodsqty; 
    setItemValue(getRow(), "GOODSQTY", goodsqty);
    String sql = " select d.toprice,d.priceid from web_custom_pr_def_v w,bms_entry_pralter_dtl_v d where w.storageid = d.priceid and w.compayid = " + hid + " and  " + 
      " d.goodsid = " + goodsid + " ";
    RemotesqlHelper rh = new RemotesqlHelper();
    DBTableModel model = null;
    try {
      model = rh.doSelect(sql, 0, 1);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    if (model != null && model.getRowCount() > 0) {
      String unitprice = model.getItemValue(0, "toprice");
      String priceid = model.getItemValue(0, "priceid");
      setItemValue(getRow(), "PRICEID", priceid);
      setItemValue(getRow(), "UNITPRICE", unitprice);
      String amount = DecimalHelper.multi(goodsqty, unitprice, 2);
      setItemValue(getRow(), "AMOUNT", amount);
    } 
    setItemValue(getRow(), "LOTNO", dbTableModel.getItemValue(selectedRows[0], "LOTNO"));
    setItemValue(getRow(), "PRODDATE", dbTableModel.getItemValue(selectedRows[0], "PRODDATE"));
    setItemValue(getRow(), "INVALIDDATE", dbTableModel.getItemValue(selectedRows[0], "INVALIDDATE"));
    setItemValue(getRow(), "FACTORYNAME", dbTableModel.getItemValue(selectedRows[0], "FACTORYNAME"));
    setItemValue(getRow(), "REGISTDOCNO", dbTableModel.getItemValue(selectedRows[0], "REGISTDOCNO"));
    setItemValue(getRow(), "USESTATUS", "1");
    setItemValue(getRow(), "GOODSDTLID", dbTableModel.getItemValue(selectedRows[0], "GOODSDTLID"));
    setItemValue(getRow(), "BATCHID", dbTableModel.getItemValue(selectedRows[0], "BATCHID"));
    setItemValue(getRow(), "LOTID", dbTableModel.getItemValue(selectedRows[0], "LOTID"));
    String posid = dbTableModel.getItemValue(selectedRows[0], "POSID");
    if (posid == null || "".equals(posid))
      posid = "0"; 
    setItemValue(getRow(), "POSID", posid);
    setItemValue(getRow(), "GOODSSTATUSID", dbTableModel.getItemValue(selectedRows[0], "GOODSSTATUSID"));
    setItemValue(getRow(), "GOODSUSEUNIT", dbTableModel.getItemValue(selectedRows[0], "GOODSUSEUNIT"));
    ClientRequest req = new ClientRequest();
    req.addCommand((CommandBase)new StringCommand("husemv_order_dtl.库存数据匹配"));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "rid")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "id")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "goodsid")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "goodsdtlid")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "lotid")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "batchid")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "posid")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "goodsstatusid")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hgoodsqty")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "goodsqty")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hunitprice")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hgoodscode")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hgoodsname")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hgoodstype")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hgoodsuseunit")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hlotno")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hproddate")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hinvaliddate")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "usedate")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hfactoryname")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hregistdocno")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "storageid")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "hid")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "goodsname")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "goodstype")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "priceid")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "unitprice")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "lotno")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "proddate")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "invaliddate")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "factoryname")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "registdocno")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "usestatus")));
    req.addCommand((CommandBase)new StringCommand(getItemValue(getRow(), "goodsuseunit")));
    req.addCommand((CommandBase)new StringCommand(erpgoodsqty));
    req.addCommand((CommandBase)new StringCommand(dbTableModel.getItemValue(selectedRows[0], "")));
    ServerResponse resp = null;
    try {
      resp = SendHelper.sendRequest(req);
      String sercmd = ((StringCommand)resp.commandAt(0)).getString();
      if (sercmd.startsWith("+OK")) {
        infoMessage("提示", "库存数据匹配成功!");
        doRequery();
      } else {
        infoMessage("提示", "库存数据匹配失败，原因:" + sercmd);
        setItemValue(getRow(), "GOODSID", "");
        setItemValue(getRow(), "GOODSNAME", "");
        setItemValue(getRow(), "GOODSTYPE", "");
        setItemValue(getRow(), "PRICEID", "");
        setItemValue(getRow(), "UNITPRICE", "");
        setItemValue(getRow(), "AMOUNT", "");
        setItemValue(getRow(), "LOTNO", "");
        setItemValue(getRow(), "PRODDATE", "");
        setItemValue(getRow(), "INVALIDDATE", "");
        setItemValue(getRow(), "FACTORYNAME", "");
        setItemValue(getRow(), "REGISTDOCNO", "");
        setItemValue(getRow(), "USESTATUS", "1");
        setItemValue(getRow(), "GOODSDTLID", "");
        setItemValue(getRow(), "BATCHID", "");
        setItemValue(getRow(), "LOTID", "");
        setItemValue(getRow(), "POSID", "");
        setItemValue(getRow(), "GOODSSTATUSID", "");
        setItemValue(getRow(), "GOODSUSEUNIT", "");
        setItemValue(getRow(), "GOODSQTY", "");
      } 
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  public void recreateDBModel() {
    super.recreateDBModel();
    TableColumnModel columnModel = this.table.getColumnModel();
    for (int i = 0; i < columnModel.getColumnCount(); i++) {
      TableColumn column = columnModel.getColumn(i);
      DBColumnDisplayInfo dbColumnDisplayInfo;
      if (!(dbColumnDisplayInfo = this.formcolumndisplayinfos.elementAt(column.getModelIndex())).getColtype().equals("行号"))
        column.setCellRenderer((TableCellRenderer)new ColorcellRender(this, dbColumnDisplayInfo)); 
    } 
  }
}
